import java.awt.*;
import java.io.*;
import java.net.*;

public class Bildwechsler extends java.applet.Applet implements Runnable {

  Image image;
  int anzahl;
  String loop;
  String[] s_image; 
  int[] pause;
  int counter;
  Thread runner;
  int int_currImg;
  String[] horiz_Ausr; 
  String[]  vertical_Ausr;
  String vertical, horiz;
  
  URL theURL = null;
  URLConnection conn;
  DataInputStream data = null;
  
  MediaTracker tracker;
 
  final String TOP = "TOP";
  final String BOTTOM = "BOTTOM";
  final String CENTER = "CENTER";
  final String LEFT = "LEFT";
  final String RIGHT = "RIGHT";

  

  public void init() {
    try {
      setBackground(new Color(Integer.parseInt(getParameter("bgcolor"),16)));
    }
    catch (Exception E) { } 
    
    tracker = new MediaTracker(this);

    String url = getParameter("file");
    try { 
      theURL = new URL(getCodeBase(), url); 
    }
    catch ( MalformedURLException e) {   }

    try { 
      conn = theURL.openConnection();
      conn.connect();
      data = new DataInputStream(new BufferedInputStream(conn.getInputStream()));
      
      anzahl = Integer.parseInt(data.readLine());
      loop = data.readLine();

      s_image = new String[anzahl];
      pause = new int[anzahl];
      horiz_Ausr = new String[anzahl];
      vertical_Ausr = new String[anzahl];

      for (counter = 0; counter < anzahl; counter++) {
        s_image[counter] = data.readLine();
        pause[counter] = Integer.parseInt(data.readLine());
        horiz_Ausr[counter] = data.readLine();
        vertical_Ausr[counter] = data.readLine();
      }
    }
    catch (IOException e) {     }
  }

  
  public void start() {
    if (runner == null); {
      runner = new Thread(this);
      runner.start();
    }
  }
 
  public void stop() {
    if (runner != null) {
      runner.stop();
      runner = null;
    }
  }


  public void run() {
    if (loop.equals("true")) {
      while (true) {
        for (int_currImg = 0; int_currImg < anzahl; int_currImg++) {
          image = getImage(getCodeBase(), s_image[int_currImg]);
          tracker.addImage(image,0);
          try {
            tracker.waitForAll();
          }
          catch(InterruptedException ex){}
          horiz = horiz_Ausr[int_currImg];
          vertical = vertical_Ausr[int_currImg];
          repaint();
          try {
            Thread.sleep(pause[int_currImg]);
          }
          catch(InterruptedException ex){}
        }
      }
    }
    else { 
      for (int_currImg = 0; int_currImg < anzahl; int_currImg++) {
        image = getImage(getCodeBase(), s_image[int_currImg]);
        tracker.addImage(image,0);
        try {
          tracker.waitForAll();
        }
        catch(InterruptedException ex) {  }  
        horiz = horiz_Ausr[int_currImg];
        vertical = vertical_Ausr[int_currImg];
        repaint();
        try {
          Thread.sleep(pause[int_currImg]);
        }
        catch(InterruptedException ex) { }
      }
    } 
  }  

  
  public void paint(Graphics g) {
    int xpos = 0, ypos = 0;

    if (horiz.equals(LEFT)) xpos = 0;
    else if (horiz.equals(RIGHT)) xpos = this.size().width - image.getWidth(this);
    else if (horiz.equals(CENTER)) xpos = (this.size().width - image.getWidth(this)) /2;
    if (vertical.equals(TOP)) ypos = 0;
    else if (vertical.equals(CENTER)) ypos = (this.size().height - image.getHeight(this)) /2;
    else if (vertical.equals(BOTTOM)) ypos = this.size().height - image.getHeight(this);
    g.drawImage(image, xpos, ypos, this);
  }


  public boolean mouseEnter(Event evt, int x, int y) {
    getAppletContext().showStatus("");
    return true;
    /* dient zum Verbergen der 'java.lang.NullPointerException' die bei mir immer auftritt
      ohne dass ich wei warum (kann mir das jemand sagen ? - MarkusWestphal@T-Online.de) */
  }


  public String getAppletInfo() {
    return "Bildwechsler Applet by Markus Westphal (MarkusWestphal@T-Online.de) (c) 1997";
  }  
}